## get nmf parameters
## get pretreated data and load packages
source('./pretreat.R')

## data: the matrix to be factorized
## mink: minimum value of rank 
## maxk: maximun value of rank
## folds: number of folds for cross-validation (cv)

nmfcvcell <- function(data,mink,maxk,folds){
  resall <- NULL
  n <- nrow(data)
  m <- ncol(data)
  cutoff <- quantile(data, 0.75)
  q1 <- which(data >= cutoff)
  q2 <- which(data < cutoff)
  id1 <- sample(1:folds, length(q1), replace = TRUE)
  id2 <- sample(1:folds, length(q2), replace = TRUE)
  for(k in mink:maxk){
    res <- 0
    for(i in 1:folds){
      train <- data
      idtest <- c(q1[id1 == i], q2[id2 == i])
      test <- data[idtest]
      w <- matrix(1, n, m)
      w[idtest] <- 0
      resfit1 <- nmf(t(train), rank = k, 
                     method = 'ls-nmf', 
                     seed = 'nndsvd', 
                     weight = t(w))
      testpre <- t(fitted(resfit1))[idtest]
      res <- res + sum((test-testpre)^2)
    }
    resall <- c(resall, res/n/m)
  }
  return(resall) 
}

set.seed(100)
for(i in 1:(nperiod)){
  nmfdat <- fdat[,c((startdate - 1):(startdate + gap*i - 2))]
  ## use cv to find rank
  rsscv <- nmfcvcell(as.matrix(nmfdat), 2, min(12,ncol(nmfdat)), 10)
  ## save cv results for each period for analysis
  write.table(rsscv, 
              paste0('0322-', 
                     datelist[startdate + gap*i - 1], 
                     '.txt'), 
              sep = ";")
}